(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){
const DEBUG=true;

const syntax = require('./syntax');
const events = {
    update: function(ui) {
      console.log("general update");
      updateModelLabels(ui,this);
      calcCustomVariables(ui,this);
      updateSuppliers(ui,this);
      cleanEndogenousTerms(ui,this);
      cleanSecondOrder(ui,this);
      cleanEsem(ui,this);
    
      update_syntax(ui,this); 

    },

    onChange_items_changed: function(ui) {
    console.log("items changed");
      updateModelLabels(ui,this);
      updateSuppliers(ui,this);
      cleanEndogenousTerms(ui,this);
      cleanSecondOrder(ui,this);
      cleanEsem(ui,this);
      update_syntax(ui,this);
    },

    onChange_latentName: function(ui) {
     console.log("change latent name");
     updateSuppliers(ui,this);
     cleanEndogenousTerms(ui,this);
     cleanSecondOrder(ui,this);
     cleanEsem(ui,this);
     update_syntax(ui,this);

    },
    onChange_SecondName: function(ui) {
     console.log("change second name");
     updateSuppliers(ui,this);
     cleanEndogenousTerms(ui,this);
     cleanSecondOrder(ui,this);
     update_syntax(ui,this);

    },

     onChange_endogenousTerms: function(ui) {
       console.log(" endogenousTerms changed"); 
       cleanSelfEndogenous(ui,this);
       update_syntax(ui,this);

    },
    onChange_endogenousSupplier: function(ui) {
     console.log("endosupplier change");

    },
    onUpdate_endogenousSupplier: function(ui) {
     console.log("endosupplier update");

    },

    onChange_secondorderSupplier: function(ui) {
     console.log("secondorder supplier change");

    },
    onUpdate_secondorderSupplier: function(ui) {
     console.log("second order supplier update");
    },
    onChange_secondorderTerms: function(ui) {
       console.log(" secondorderTerms changed"); 
       cleanSelfSecondorder(ui,this);
       update_syntax(ui,this);

    },

    onChange_varcov: function(ui) {

      update_syntax(ui,this);
    },
 
    onChange_varcovSupplier: function(ui) {
        let values = this.itemsToValues(ui.varcovSupplier.value());
        this.checkPairsValue(ui.varcov, values);
      
    },
    onUpdate_varcovSupplier: function(ui) {
      console.log("varcovsup update");
      
    },
    
    onChange_constraints: function(ui) {
      console.log("constraints changed");
      update_syntax(ui,this);
      
      
    },

     onChange_multigroup: function(ui) {
       
       var val = ui.multigroup.value();
       if (typeof(val)==="string")
             if (val.replace(/ /g,'').length===0)
                ui.multigroup.setValue(null);
             else {
               var vars=ui.vars.value();
               let newvars=vars.map((x) => x);
                   if (!newvars.includes(val)) newvars.push(val);
                   ui.vars.setValue(newvars);
             }

     },
      onChange_cluster: function(ui) {
       console.log("Multilevel cluster changed");
       var val = ui.cluster.value();
       if (typeof(val)==="string")
             if (val.replace(/ /g,'').length===0)
                ui.cluster.setValue(null);
        else {
               var vars=ui.vars.value();
               let newvars=vars.map((x) => x);
                   if (!newvars.includes(val)) newvars.push(val);
                   ui.vars.setValue(newvars);
             }        
     },

     onEvent_nothing: function(ui) {
      console.log("I did not do anything");
    }



};



var initializeAll = function(ui, context) {
    console.log("initialize all");
//    updateSuppliers(ui,context);
//    prepareEndogenousTerms(ui,context);

};




const calcCustomVariables=function(ui,context) {
  
  console.log("calcCustomVariables");
  var endogenousIndicators=context.cloneArray(ui.endogenous.value(),[]);
  var exogenousIndicators=context.cloneArray(ui.exogenous.value(),[]);
  var secondorderIndicators=context.cloneArray(ui.secondorder.value(),[]);

  var endogenous=getLabels(endogenousIndicators);
  var exogenous=getLabels(exogenousIndicators);
  var secondorder=getLabels(secondorderIndicators);

  var latent=endogenous.concat(exogenous);
      latent=latent.concat(secondorder);

  let customVariables = [];
    for(let i = 0; i < latent.length; i++) {
        customVariables.push( { name: latent[i], measureType: 'none', dataType: 'none', levels: [] } );
    }
  context.setCustomVariables(customVariables);

  
};

const updateSuppliers=function(ui, context) {
  
  console.log("updateSuppliers function");
  var endogenousIndicators=context.cloneArray(ui.endogenous.value(),[]);
  var exogenousIndicators=context.cloneArray(ui.exogenous.value(),[]);
  var secondorderIndicators=context.cloneArray(ui.secondorder.value(),[]);

  var endogenous=getLabels(endogenousIndicators);
  var exogenous=getLabels(exogenousIndicators);
  var secondorder=getLabels(secondorderIndicators);

  var latent=endogenous.concat(exogenous);

 // esem accept only  first order factors
    ui.esemSupplier.setValue(context.valuesToItems(latent, FormatDef.variable));

 // the other suppliers need also the second order factors  
    latent=latent.concat(secondorder);

  let customVariables = [];
    for(let i = 0; i < latent.length; i++) {
        customVariables.push( { name: latent[i], measureType: 'none', dataType: 'none', levels: [] } );
    }

  context.setCustomVariables(customVariables);
  ui.endogenousSupplier.setValue(context.valuesToItems(latent, FormatDef.variable));
  ui.secondorderSupplier.setValue(context.valuesToItems(latent, FormatDef.variable));

  var vars=[];  
   for (var i = 0; i < endogenousIndicators.length; i++) {
      if  (endogenousIndicators[i]!==undefined)
        if  (endogenousIndicators[i].vars!==undefined & endogenousIndicators[i].vars!==null) {
             for (var j = 0; j < endogenousIndicators[i].vars.length; j++) {
                vars.push(endogenousIndicators[i].vars[j]); 
             }
        }
     }
   for (var i = 0; i < exogenousIndicators.length; i++) {
      if  (exogenousIndicators[i]!==undefined)
        if  (exogenousIndicators[i].vars!==undefined & exogenousIndicators[i].vars!==null) {
             for (var j = 0; j < exogenousIndicators[i].vars.length; j++) {
                vars.push(exogenousIndicators[i].vars[j]); 
             }
        }
     }

  var allvars=unique(latent.concat(vars));
  ui.varcovSupplier.setValue(context.valuesToItems(allvars, FormatDef.variable));
  context.workspace.varcovSupplierList=allvars;

};

const updateModelLabels = function(ui,context) {
  
    var list1 = ui.endogenous.applyToItems(0, (item, index) => {
        let value = item.controls[0].value();
        if ( ! value || value.trim() === '')
            item.controls[0].setValue("Endogenous" + (index + 1) );
    });
    var list2 = ui.exogenous.applyToItems(0, (item, index) => {
        let value = item.controls[0].value();
        if ( ! value || value.trim() === '')
            item.controls[0].setValue("Exogenous" + (index + 1) );
    });
    
    var list3 = ui.secondorder.applyToItems(0, (item, index) => {
        let value = item.controls[0].value();
        if ( ! value || value.trim() === '')
            item.controls[0].setValue("Factor " + (index + 1) );
    });
    

};

var prepareEndogenousTerms= function(ui,context) {

     // here we prepare a list of lists, one of each endogenous variable.
     // we also want to put a label to show which dependent variable the user is working on

     console.log("prepareEndogenousTerms");
     var endogenous = getLabels(context.cloneArray(ui.endogenous.value(),[]));
     var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);
     var secondorder = getLabels(context.cloneArray(ui.secondorder.value(),[]));
     endogenous = endogenous.concat(secondorder);
     
 
     // we make sure that there are enough arrays in the array list, each for each endogeneous
     var okList= [];
     for (var i = 0; i < endogenous.length; i++) {
         var aList = endogenousTerms[i] === undefined ? [] : endogenousTerms[i] ;
             okList.push(aList);
     }
      ui.endogenousTerms.setValue(okList);    

     // we give a label for each endogenous model
     labelize(ui.endogenousTerms, endogenous, "Endogenous");
  
     console.log("....end");
};


var cleanEndogenousTerms= function(ui,context) {

    console.log("cleanEndogenousTerms");
    prepareEndogenousTerms(ui,context);
    var endogenous  = getLabels(context.cloneArray(ui.endogenous.value(), []));
    var secondorder = getLabels(context.cloneArray(ui.secondorder.value(), []));
        endogenous  = endogenous.concat(secondorder);
        
    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);

    for (var i = 0; i < endogenous.length; i++) {
        endogenousTerms[i]=removeFromList(endogenous[i],endogenousTerms[i],context,1);
    }

    var endogenousSupplierList = context.cloneArray(context.itemsToValues(ui.endogenousSupplier.value()),[]);

    var diff = context.findChanges("endogenousSupplierList",endogenousSupplierList,context);
    
    if (diff.hasChanged) {
      for (var i = 0; i < endogenousTerms.length; i++) 
           for (var j = 0; j < diff.removed.length; j++) {
                endogenousTerms[i]=removeFromList(diff.removed[j],endogenousTerms[i],context,1);
           }
    }
    ui.endogenousTerms.setValue(endogenousTerms);
    storeComponent("endogenousTerms",endogenousTerms,context);
    

};

var cleanSelfEndogenous=function(ui,context) {
  
    var endogenous  = getLabels(context.cloneArray(ui.endogenous.value(), []));
    var secondorder = getLabels(context.cloneArray(ui.secondorder.value(), []));
        endogenous  = endogenous.concat(secondorder);
        
    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);

    for (var i = 0; i < endogenous.length; i++) {
        endogenousTerms[i]=removeFromList(endogenous[i],endogenousTerms[i],context,1);
    }
  
    ui.endogenousTerms.setValue(endogenousTerms);
    storeComponent("endogenousTerms",endogenousTerms,context);
  
  
}


var cleanSecondOrder= function(ui,context) {

    console.log("cleanSecondOrder");
    var secondorderTerms = context.cloneArray(ui.secondorder.value(),[]);

    var secondorderSupplierList = context.cloneArray(context.itemsToValues(ui.secondorderSupplier.value()),[]);
    var diff = context.findChanges("secondorderSupplierList",secondorderSupplierList,context);

    if (diff.hasChanged) {
    var vars=[];    
      for (var i = 0; i < secondorderTerms.length; i++) 
            for (var j = 0; j < diff.removed.length; j++) {
//                secondorderTerms[i].vars=removeFromList(diff.removed[j],secondorderTerms[i].vars,context,1);
                if (secondorderTerms[i].vars!==null) {
                    vars=removeFromList(diff.removed[j],secondorderTerms[i].vars,context,1);
                    // the remove function was written for arrays of array. Here we need
                    // arrays of string, so we fixed brutaly. Needs work.
                    vars=vars.map(function(e) { return e.join("")});
                    secondorderTerms[i].vars=vars;
                }

            }
    }

    ui.secondorder.setValue(secondorderTerms);
};


var cleanSelfSecondorder=function(ui,context) {
  
    var secondorderTerms = context.cloneArray(ui.secondorder.value(), []);
    var secondorder=getLabels(secondorderTerms);
    var vars=[];

    for (var i = 0; i < secondorder.length; i++) {
            if (secondorderTerms[i].vars!==null) {
                    vars=removeFromList(secondorder[i],secondorderTerms[i].vars,context,1);
                    // the remove function was written for arrays of array. Here we need
                    // arrays of string, so we fixed brutaly. Needs work.
                    vars=vars.map(function(e) { return e.join("")});
                    secondorderTerms[i].vars=vars;
       }
     }
  
    ui.secondorder.setValue(secondorderTerms);

}

var cleanEsem= function(ui,context) {

    console.log("cleanEsem");
    var esemTerms = context.cloneArray(ui.esem_terms.value(),[]);
    console.log(esemTerms);
    var esemSupplierList = context.cloneArray(context.itemsToValues(ui.esemSupplier.value()),[]);
    var diff = context.findChanges("esemSupplierList",esemSupplierList,context);
    console.log(diff);

    if (diff.hasChanged) {
      
      var esemTerms = esemTerms.map(x => {
            var n=x.filter(z => { return(!diff.removed.includes(z))} )
            return(n)
            });
    }

    ui.esem_terms.setValue(esemTerms);
};

var update_syntax=function(ui,context) {
  

    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);
    var secondorder=context.cloneArray(ui.secondorder.value(),[]);
    // second order factors can be handle like an endogenous variable
    var endogenous=context.cloneArray(ui.endogenous.value(),[]);
        endogenous=endogenous.concat(secondorder);
    
    var exogenous=context.cloneArray(ui.exogenous.value(),[]);
    var vars=exogenous.concat(endogenous);

    var varcov=context.cloneArray(ui.varcov.value(),[]);
    var constraints=context.cloneArray(ui.constraints.value(),[]);
    var is_measures= syntax.measures(vars);
    var is_terms =syntax.make(endogenousTerms,getLabels(endogenous));
    syntax.varcov(varcov);
    syntax.constraints(constraints);
    
    if (is_measures || is_terms )
             ui.code.setValue(syntax.lav_syntax);
    else    
             ui.code.setValue("")
    

};

var getLabels=function(alist,context) {
     var okList=[];
     for (var i = 0; i < alist.length; i++) {
         if (alist[i].label!==undefined) {
           if (alist[i].vars===undefined | alist[i].vars===null)
               continue;
           if (alist[i].vars.length===0)
               continue;

           okList.push(alist[i].label);
      }
     }
     return(okList);
};

var unique=function(arr) {
    var u = {}, a = [];
    for(var i = 0, l = arr.length; i < l; ++i){
        var prop=ssort(JSON.stringify(arr[i]));
        if(!u.hasOwnProperty(prop) && arr[i].length>0) {
            a.push(arr[i]);
            u[prop] = 1;
        }
    }
    return a;
};

var ssort= function(str){
  str = str.replace(/[`\[\]"\\\/]/gi, '');
  var arr = str.split(',');
  var sorted = arr.sort();
  return sorted.join('');
};


var labelize = function(widget, labels, prefix) {
     widget.applyToItems(0, (item, index) => {
           item.controls[0].setPropertyValue("label",prefix +" = "+labels[index]);
        });
};


// remove a list or a item from list
// order=0 remove only if term and target term are equal
// order>0 remove if term length>=order 
// for instance, order=1 remove any matching interaction with terms, keeps main effects
// order=2 remove from 3-way interaction on (keep up to 2-way interactions)

var removeFromList = function(quantum, cosmos, context, order = 1) {

    cosmos = normalize(context.cloneArray(cosmos));
    quantum = normalize(context.cloneArray(quantum));

 
     if (cosmos===undefined)
        return([]);
     cosmos = context.cloneArray(cosmos);
       for (var i = 0; i < cosmos.length; i++) {
          if (cosmos[i]===undefined)
             break;
          var aCosmos = context.cloneArray(cosmos[i]);
           for (var k = 0; k < quantum.length; k++) {
             var  test = order === 0 ? FormatDef.term.isEqual(aCosmos,quantum[k]) : FormatDef.term.contains(aCosmos,quantum[k]);
                 if (test && (aCosmos.length >= order)) {
                        cosmos.splice(i, 1);
                        i -= 1;
                    break;    
                    }
          }
            
       }
  
    return(cosmos);
};



var storeComponent = function(id,cosmos,context) {
                    context.workspace[id]=cosmos;
};


var normalize = function(cosmos) {

  if (cosmos===undefined)
          return [];
  if (dim(cosmos)===0)
          cosmos=[cosmos];
          
        for (var i = 0; i < cosmos.length; i++) {
            var aValue = cosmos[i];
            var newValue=dim(aValue)>0 ? aValue : [aValue];
            cosmos[i]=newValue;
        }
        return cosmos;
};

var dim = function(aList) {

    if (!Array.isArray(aList))
           return(0);
    if (!Array.isArray(aList[0]))
           return(1);
    if (!Array.isArray(aList[0][0]))
           return(2);
    if (!Array.isArray(aList[0][0][0]))
           return(3);
    if (!Array.isArray(aList[0][0][0][0]))
           return(4);

  
    return(value);
};



module.exports = events;


},{"./syntax":3}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data","description":{"R":"TO ADD\n"}},{"name":".caller","type":"String","title":"submodule","default":"gui","hidden":true},{"name":"code","default":"","type":"String","hidden":true,"description":{"R":"The lavaan syntax\n"}},{"name":"donotrun","type":"Bool","title":"Do not run","description":"not present in R. Halt running for more confortable input"},{"name":"endogenous","type":"Array","default":[{"label":"Endogenous1","vars":[]}],"template":{"type":"Group","elements":[{"name":"label","type":"String"},{"name":"vars","type":"Variables","suggested":["continuous"],"permitted":["numeric"]}]},"description":{"R":"A list containing named lists that define the `label` of the latent endogenous variable(s) and the `vars` that belong to that latent.\n"}},{"name":"exogenous","type":"Array","default":[{"label":"Exogenous1","vars":[]}],"template":{"type":"Group","elements":[{"name":"label","type":"String"},{"name":"vars","type":"Variables","suggested":["continuous"],"permitted":["numeric"]}]},"description":{"R":"A list containing named lists that define the `label` of the latent exogenous variables and the `vars` that belong to that latent.\n"}},{"name":"secondorder","type":"Array","default":[{"label":"Factor1","vars":[]}],"template":{"type":"Group","elements":[{"name":"label","type":"String"},{"name":"vars","type":"Terms"}]},"description":{"R":"A list containing named lists that define the `label` of the second order latent factors  and the `vars` that belong to that latent.\n"}},{"name":"endogenousTerms","title":"Endogenous Latent Variable Models","type":"Array","default":[[]],"template":{"type":"Terms"},"description":{"R":"A list of lists specifying the models for with the mediators as dependent variables.\n"}},{"name":"varcov","title":"Select pairs","type":"Pairs","description":{"R":"A list of lists specifying the  covariances that need to be estimated.\n"}},{"name":"constraints","title":"Insert contraints or defined parameters","type":"Array","default":[],"template":{"type":"String"},"description":{"R":"A list of lists specifying the models random effects.\n"}},{"name":"estimator","title":"Method","type":"List","options":[{"name":"default","title":"Automatic"},{"name":"ML","title":"Maximum Likelihood (ML)"},{"name":"MLM","title":"Robust Maximum Likelihood (MLM)"},{"name":"MLMV","title":"Robust Maximum Likelihood (MLMV)"},{"name":"MLMVS","title":"Robust Maximum Likelihood (MLMVS)"},{"name":"MLR","title":"Robust Maximum Likelihood (MLR)"},{"name":"PML","title":"Pairwise maximum likelihood (PML)"},{"name":"GLS","title":"Generalized Least Squares (GSL)"},{"name":"WLS","title":"Weighted Least Squares (WLS)"},{"name":"DWLS","title":"Diagonally weighted Least Squares (DWLS)"},{"name":"WLSM","title":"Robust Weighted Least Squares (WLSM)"},{"name":"WLSMV","title":"Robust Weighted Least Squares (WLSMV)"},{"name":"WLSMVS","title":"Robust Weighted Least Squares (WLSMVS)"},{"name":"ULS","title":"Unweighted Least Squares"}],"default":"default","description":{"ui":"The estimator to be used (cf. lavaan R package). Can be one of the following: \"ML\" for maximum likelihood, \"GLS\" for (normal theory) generalized least squares, \"WLS\" for weighted least squares (sometimes called ADF estimation), \"ULS\" for unweighted least squares, \"DWLS\" for diagonally weighted least squares, and \"DLS\" for distributionally-weighted least squares. These are the main options that affect the estimation. For convenience, the \"ML\" option can be extended as \"MLM\", \"MLMV\", \"MLMVS\", \"MLF\", and \"MLR\". The estimation will still be plain \"ML\", but now with robust standard errors and a robust (scaled) test statistic. For \"MLM\", \"MLMV\", \"MLMVS\", classic robust standard errors are used (se=\"robust.sem\"); for \"MLF\", standard errors are based on first-order derivatives (information = \"first.order\"); for \"MLR\", `Huber-White` robust standard errors are used (se=\"robust.huber.white\"). In addition, \"MLM\" will compute a Satorra-Bentler scaled (mean adjusted) test statistic (test=\"satorra.bentler\"), \"MLMVS\" will compute a mean and variance adjusted test statistic (Satterthwaite style) (test=\"mean.var.adjusted\"), \"MLMV\" will compute a mean and variance adjusted test statistic (scaled and shifted) (test=\"scaled.shifted\"), and \"MLR\" will compute a test statistic which is asymptotically equivalent to the Yuan-Bentler T2-star test statistic (test=\"yuan.bentler.mplus\"). Analogously, the estimators \"WLSM\" and \"WLSMV\" imply the \"DWLS\" estimator (not the \"WLS\" estimator) with robust standard errors and a mean or mean and variance adjusted test statistic. Estimators \"ULSM\" and \"ULSMV\" imply the \"ULS\" estimator with robust standard errors and a mean or mean and variance adjusted test statistic.\n","R":"The estimator to be used. Can be one of the following: \"ML\" for maximum likelihood, \"GLS\" for (normal theory) generalized least squares, \"WLS\" for weighted least squares (sometimes called ADF estimation), \"ULS\" for unweighted least squares, \"DWLS\" for diagonally weighted least squares, and \"DLS\" for distributionally-weighted least squares. These are the main options that affect the estimation. For convenience, the \"ML\" option can be extended as \"MLM\", \"MLMV\", \"MLMVS\", \"MLF\", and \"MLR\". The estimation will still be plain \"ML\", but now with robust standard errors and a robust (scaled) test statistic. For \"MLM\", \"MLMV\", \"MLMVS\", classic robust standard errors are used (se=\"robust.sem\"); for \"MLF\", standard errors are based on first-order derivatives (information = \"first.order\"); for \"MLR\", `Huber-White` robust standard errors are used (se=\"robust.huber.white\"). In addition, \"MLM\" will compute a Satorra-Bentler scaled (mean adjusted) test statistic (test=\"satorra.bentler\"), \"MLMVS\" will compute a mean and variance adjusted test statistic (Satterthwaite style) (test=\"mean.var.adjusted\"), \"MLMV\" will compute a mean and variance adjusted test statistic (scaled and shifted) (test=\"scaled.shifted\"), and \"MLR\" will compute a test statistic which is asymptotically equivalent to the Yuan-Bentler T2-star test statistic (test=\"yuan.bentler.mplus\"). Analogously, the estimators \"WLSM\" and \"WLSMV\" imply the \"DWLS\" estimator (not the \"WLS\" estimator) with robust standard errors and a mean or mean and variance adjusted test statistic. Estimators \"ULSM\" and \"ULSMV\" imply the \"ULS\" estimator with robust standard errors and a mean or mean and variance adjusted test statistic.\n"}},{"name":"likelihood","title":"ML likelihood approach","type":"List","options":[{"name":"default","title":"Automatic"},{"name":"normal","title":"Normal"},{"name":"wishart","title":"Wishart"}],"default":"default","description":{"ui":"Only relevant for ML estimation. If \"Wishart\", the Wishart likelihood approach is used. In this approach, the covariance matrix has been divided by N-1, and both standard errors and test statistics are based on N-1. If \"Normal\" or \"Automatic\", the normal likelihood approach is used. Here, the covariance matrix has been divided by N, and both standard errors and test statistics are based on N.\n","R":"Only relevant for ML estimation. If \"wishart\", the wishart likelihood approach is used. In this approach, the covariance matrix has been divided by N-1, and both standard errors and test statistics are based on N-1. If \"normal\", the normal likelihood approach is used. Here, the covariance matrix has been divided by N, and both standard errors and test statistics are based on N. If \"default\", it depends on the mimic option: if mimic=\"lavaan\" or mimic=\"Mplus\", normal likelihood is used; otherwise, wishart likelihood is used.\n"}},{"name":"missing","title":"Missing values","type":"List","options":[{"name":"listwise","title":"Delete listwise"},{"name":"ml","title":"FIML"},{"name":"ml.x","title":"FIML (including fixed x)"},{"name":"robust.two.stage","title":"Two stages (robust)"},{"name":"pairwise","title":"pairwise"}],"default":"listwise","description":{"R":"Handling of missing values. `listwise` delete rows with missing.  `missing=ml` for ‘full information’ maximum likelihood estimation. `missing=ml.x` for ‘full information’ maximum likelihood estimation  that includes also the fixed exogenous variables. `ml=robust.two.stage` uses a two stage appraoch whereas `ml=pairwise` delete case pairwise before computing the covariances between variables.\n","ui":"Handling of missing values. `listwise` delete rows with missing. \n `FIML` for ‘full information’ maximum likelihood estimation.\n `FIML (including fixed x)` for ‘full information’ maximum likelihood estimation \n that includes also the fixed exogenous variables. `Two stages (robust)`\n uses a two stage appraoch whereas `Pairwise` deletes case pairwise\n before computing the covariances between variables.\n"}},{"name":"scoretest","type":"Bool","title":"Univariate","default":true,"description":{"ui":"Score test (or Lagrange Multiplier test) for fixed or constrained parameters in model.\n","R":"TO ADD\n"}},{"name":"cumscoretest","type":"Bool","title":"Cumulative","default":false,"description":{"ui":"Score test for all fixed or constrained parameters in model (cumulative tests).\n","R":"TO ADD\n"}},{"name":"se","type":"List","title":"Standard errors","options":[{"name":"auto","title":"Automatic"},{"name":"standard","title":"Standard"},{"name":"robust.sem","title":"Robust"},{"name":"robust.sem","title":"Robust for Clusters"},{"name":"robust.huber.white","title":"Pseudo ML"},{"name":"boot","title":"Bootstrap"}],"default":"auto","description":{"R":"Standard error method.\n"}},{"name":"bootci","title":"Bootstrap C.I","type":"List","options":[{"name":"perc","title":"percentiles"},{"name":"bca.simple","title":"adjusted bias-corrected"},{"name":"norm","title":"normal"},{"name":"basic","title":"basic"}],"default":"perc","description":{"R":"Choose the confidence interval type (\"perc\" - percentiles [default], \"bca.simple\" - adjusted bias-corrected, \"norm\" - normal, \"basic\" - basic).\n"}},{"name":"bootN","title":"Bootstrap Rep.","type":"Number","min":50,"default":1000,"description":{"R":"The number of bootstrap samples for estimating confidence intervals.\n"}},{"name":"parallel","title":"Parallel Computation","type":"Bool","default":false,"description":{"R":"use parallel computation for bootstrap C.I\n"}},{"name":"est_ci","title":"Estimates","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), show confidence intervals for estimates\n"}},{"name":"beta_ci","title":"Betas","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show confidence intervals for standardized estimates\n"}},{"name":"ci_width","title":"Confidence level","type":"Number","min":50,"max":99.9,"default":95,"description":{"R":"A number between 50 and 99.9 (default: 95) specifying the confidence interval width for the parameter estimates.\n"}},{"name":"meanstructure","type":"Bool","title":"Mean structure","default":true,"description":{"R":"If TRUE, the means of the observed variables enter the model. Required for calculating the intercepts of the estimates.\n"}},{"name":"int_ov","type":"Bool","title":"Observed variables","default":true,"description":{"R":"`TRUE` or `FALSE` (default), calculate intercepts for observed variables\n"}},{"name":"int_lv","type":"Bool","title":"Latent variables","default":false,"description":{"R":"`TRUE` or `FALSE` (default), calculate intercepts for latent variables\n"}},{"name":"indirect","type":"Bool","title":"Indirect Effects","default":false,"description":{"ui":"compute the indirect effect by finding all paths from exogenous to endogenous variables, and multiply the coefficients along the path.\n","R":"`TRUE` or `FALSE` (default), TO ADD\n"}},{"name":"std_lv","title":"Scale / stand. latent vars.","type":"List","options":[{"name":"fix_first","title":"Latent vars.: Fix first indicator (to 1)"},{"name":"std_res","title":"Latent vars.: Fix residual variances (to 1)"}],"default":"fix_first","description":{"ui":"If `Fix first indicator` (default), the factor loading of the first indicator is set to 1.0 for every latent variable. If `Fix residual variances`, the metric of each latent variable is determined by fixing their (residual) variances to 1.0. If there are multiple groups, `Fix residual variances` is chosen and \"loadings\" is included in the group.label argument, then only the latent variances i of the first group will be fixed to 1.0, while the latent variances of other groups are set free.\n","R":"If `fix_first` (default), the factor loading of the first indicator is set to 1.0 for every latent variable. If `std_res`, the metric of each latent variable is determined by fixing their (residual) variances to 1.0. If there are multiple groups, \"std_res\" is chosen and \"loadings\" is included in the group.label argument, then only the latent variances i of the first group will be fixed to 1.0, while the latent variances of other groups are set free.\n"}},{"name":"std_ov","type":"Bool","title":"Observed vars.: Standardize before estimation","default":false,"description":{"R":"If TRUE, all observed variables are standardized before entering the analysis.\n","ui":"If set, all observed variables are standardized before entering the analysis.\n"}},{"name":"cov_x","type":"Bool","title":"Fix exogenous covariates","default":false,"description":{"R":"If `TRUE`, the exogenous covariates are considered fixed variables and the means, variances and covariances of these variables are fixed to their sample values. If `FALSE`, they are considered random, and the means, variances and covariances are free parameters. If \"default\", the value is set depending on the mimic option.\n"}},{"name":"cov_y","type":"Bool","title":"Dependent vars (y)","default":true,"description":{"R":"`TRUE` (default) or `FALSE`, TO ADD\n"}},{"name":"cov_lv","type":"Bool","title":"Latent vars","default":true,"description":{"R":"`TRUE` (default) or `FALSE`, is the negation of orthogonal option\n"}},{"name":"cluster","default":"","type":"String","hidden":true,"description":{"R":"Not used in gui\n"}},{"name":"multigroup","title":"Multigroup Analysis Factor","type":"Variable","suggested":["nominal","ordinal"],"permitted":["factor"],"default":null,"description":{"R":"Factor defining groups for multigroup analysis."}},{"name":"eq_loadings","type":"Bool","title":"Loadings","default":false,"description":{"ui":"constrain the factor loadings to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the factor loadings to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_intercepts","type":"Bool","title":"Intercepts","default":false,"description":{"ui":"constrain the intercepts of the observed variables to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the intercepts of the observed variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_residuals","type":"Bool","title":"Residuals","default":false,"description":{"ui":"constrain the residual variances of the observed variables to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the residual variances of the observed variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_residual.covariances","type":"Bool","title":"Residual covariances","default":false,"description":{"ui":"constrain the residual covariances of the observed variables to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the residual covariances of the observed variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_means","type":"Bool","title":"Means","default":false,"description":{"ui":"constrain the intercepts / means of the latent variables to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the intercepts / means of the latent variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_thresholds","type":"Bool","title":"Threshold","default":false,"description":{"ui":"constrain the sample-based thresholds (means for continuous observed mvariables) to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the sample-based thresholds (means for continuous observed mvariables) to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_regressions","type":"Bool","title":"Regressions","default":false,"description":{"ui":"constrain all regression coefficients in the model to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain all regression coefficients in the model to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_lv.variances","type":"Bool","title":"Latent variances","default":false,"description":{"ui":"constrain the (residual) variances of the latent variables to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the (residual) variances of the latent variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"eq_lv.covariances","type":"Bool","title":"Latent covariances","default":false,"description":{"ui":"constrain the (residual) covariances of the latent variables to be equal across groups (when conducting multi-group analyses)\n","R":"`TRUE` or `FALSE` (default), constrain the (residual) covariances of the latent variables to be equal across groups (when conducting multi-group analyses)\n"}},{"name":"esem_terms","type":"Array","default":[[]],"template":{"type":"Variables"},"description":{"R":"A list of list containing blocks of factors to be factorialized toghether.\n"}},{"name":"rotation","title":"Method","type":"List","options":[{"name":"geomin","title":"Geomin"},{"name":"varimax","title":"Varimax"},{"name":"orthomax","title":"Orthomax"},{"name":"quartimin","title":"Quartimin"},{"name":"oblimin","title":"Oblimin"},{"name":"entropy","title":"Entropy"},{"name":"mccammon","title":"Mccammon"},{"name":"infomax","title":"Infomax"},{"name":"tandem1","title":"Tandem1"},{"name":"oblimax","title":"Oblimax"},{"name":"bentler","title":"Bentler"},{"name":"simplimax","title":"Simplimax"}],"default":"geomin","description":{"R":"Rotation methods as implemented in lavaan >0.6-13\n"}},{"name":"algorithm","title":"Algotrithm","type":"List","options":[{"name":"gpa","title":"gpa"},{"name":"pairwise","title":"pairwise"}],"default":"gpa","description":{"R":"Optional algorithm for rotation, derfaul is `gpa`\n"}},{"name":"orthogonal","type":"Bool","title":"Orthogonal","default":false,"description":{"R":"`TRUE` or `FALSE` (default), whether the roation should be orthogonal\n"}},{"name":"efa_std.ov","type":"Bool","title":"Standardize observed vars","default":true,"description":{"R":"`TRUE` or `FALSE` (default), whether observed variables should be standardized\n"}},{"name":"geomin.epsilon","title":"Geomin Epsilon","type":"Number","min":0,"default":0.5,"description":{"R":"Geomin epsilon, default=.50\n"}},{"name":"orthomax.gamma","title":"Orthomax Gamma","type":"Number","min":0,"default":1,"description":{"R":"Geomin epsilon, default=.001\n"}},{"name":"oblimin.gamma","title":"Oblimin Gamma","type":"Number","min":0,"default":0,"description":{"R":"Oblimin gamma, default=0\n"}},{"name":"showlabels","type":"Bool","title":"Show parameters labels","default":false,"description":{"ui":"show the labels of the parameters in the model\n","R":"`TRUE` or `FALSE` (default), show the labels of the parameters in the model\n"}},{"name":"constraints_examples","type":"Bool","title":"Show syntax examples","default":false,"description":{"ui":"show examples of the lavaan model syntax\n","R":"`TRUE` or `FALSE` (default), show examples of the lavaan model syntax\n"}},{"name":"outputAdditionalFitMeasures","type":"Bool","title":"Additional fit measures","default":false,"description":{"ui":"show additional fit measures (e.g., CFI, TLI, etc.)\n","R":"`TRUE` or `FALSE` (default), show additional fit measures (e.g., CFI, TLI, etc.)\n"}},{"name":"reliability","type":"Bool","title":"Reliability indices","default":false,"description":{"ui":"shows additional reliability indices\n","R":"`TRUE` or `FALSE` (default), show additional reliability indices\n"}},{"name":"r2","type":"List","title":"R-squared","options":[{"name":"none","title":"None"},{"name":"all","title":"All"},{"name":"endo","title":"Endogenous"},{"name":"all","title":"All"}],"default":"none","description":{"R":"compute R-squared for all endogenous variables (`endo`) or for all variables in the model (`all`). `none` for no R-squared\n","ui":"compute R-squared for all endogenous variables (`Endogenous`) or for all variables in the model (`All`). `None` for no R-squared.\n"}},{"name":"htmt","type":"Bool","title":"HTMT","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show Heterotrait-monotrait (HTMT) ratio of correlations  as reccomended by @henseler2015new\n"}},{"name":"outputMardiasCoefficients","type":"Bool","title":"Mardia's coefficients","default":false,"description":{"ui":"show Mardia's coefficients for multivariate skewness and kurtosis\n","R":"`TRUE` or `FALSE` (default), show Mardia's coefficients for multivariate skewness and kurtosis\n"}},{"name":"outputObservedCovariances","type":"Bool","title":"Observed","default":false,"description":{"ui":"show the covariances and correlations between the observed values of the (manifest) variables\n","R":"`TRUE` or `FALSE` (default), show the covariances and correlations between the observed values of the (manifest) variables\n"}},{"name":"outputImpliedCovariances","type":"Bool","title":"Model-implied (fitted)","default":false,"description":{"ui":"show the covariances and correlations between the model-implied / fitted values of the (manifest) variables\n","R":"`TRUE` or `FALSE` (default), show the covariances and correlations between the model-implied / fitted values of the (manifest) variables\n"}},{"name":"outputResidualCovariances","type":"Bool","title":"Residual","default":false,"description":{"ui":"show the covariances and correlations between the residuals of the (manifest) variables.\n","R":"`TRUE` or `FALSE` (default), show the covariances and correlations between the residuals of the (manifest) variables.\n"}},{"name":"outpuCombineCovariances","type":"Bool","title":"Combined into one table","default":false,"description":{"ui":"combine the (up to) three covariance / correlation tables into one table (i.e., showing observed, model-implied and residual values for each variable combination underneath each other)\n","R":"`TRUE` or `FALSE` (default), combine the (up to) three covariance / correlation tables into one table (i.e., showing observed, model-implied and residual values for each variable combination underneath each other)\n"}},{"name":"cov.lv","type":"Bool","title":"Model-implied latent","default":false,"description":{"ui":"show model-implied latent covariances\n","R":"`TRUE` or `FALSE` (default), model-implied latent covariances\n"}},{"name":"outputModificationIndices","type":"Bool","title":"Modification indices","default":false,"description":{"ui":"show modification indices for if certain terms were removed from the model\n","R":"`TRUE` or `FALSE` (default), show modification indices for if certain terms were removed from the model\n"}},{"name":"miHideLow","type":"Bool","title":"Hide low indices","default":false,"description":{"ui":"hide modification indices below a certain threshold.\n","R":"`TRUE` or `FALSE` (default), hide modification indices below a certain threshold.\n"}},{"name":"miThreshold","type":"Number","title":"Threshold","default":10,"min":0,"description":{"R":"Numeric (default: 10), set a threshold the modification indices must exceed in order to be shown.\n"}},{"name":"diagram","title":"Path diagram","type":"Bool","default":false,"description":{"ui":"produce a path diagram.\n","R":"`TRUE` or `FALSE` (default), produce a path diagram.\n"}},{"name":"diag_resid","title":"show residuals","type":"Bool","default":false,"description":{"ui":"show the residuals (for the observed variables).\n","R":"`TRUE` or `FALSE` (default), show the residuals (for the observed variables).\n"}},{"name":"diag_intercepts","title":"show intercepts","type":"Bool","default":false,"description":{"ui":"show the variable intercepts.\n","R":"`TRUE` or `FALSE` (default), show the variable intercepts.\n"}},{"name":"diag_paths","title":"Paths Labels","type":"List","options":[{"name":"est","title":"Coefficients"},{"name":"stand","title":"Betas"},{"name":"name","title":"Labels"},{"name":"hide","title":"None"}],"default":"est","description":{"ui":"Choose the values shown along the paths.\n","R":"Choose the values shown along the paths (\"est\" [coeffic., default], \"stand\" [betas], \"name\" [labels], \"hide\" [nothing]).\n"}},{"name":"diag_type","title":"Type","type":"List","options":[{"name":"tree","title":"Tree-like"},{"name":"tree2","title":"Tree-like alt."},{"name":"circle","title":"Circular"},{"name":"circle2","title":"Circular alt."},{"name":"spring","title":"Spring"}],"default":"tree","description":{"ui":"Choose the layout of the path diagram: `Tree`, `Tree2`,`Circle`,`Circle2` , `Spring`).\n","R":"Choose the layout of the path diagram (\"tree\" [default], \"tree2\", \"circle\", \"circle2\", \"spring\").\n"}},{"name":"diag_rotate","title":"Rotate","type":"List","options":[{"name":"1","title":"Exog. top"},{"name":"2","title":"Exog. left"},{"name":"3","title":"Exog. bottom"},{"name":"4","title":"Exog. right"}],"default":"2","description":{"ui":"Choose the rotation of the path diagram in terms of placement of the exog. variables.\n","R":"Choose the rotation of the path diagram (placement of the exog. variables; \"1\": top, \"2\": left (default), \"3\": bottom, \"4\": right).\n"}},{"name":"diag_labsize","title":"Node Size","type":"List","options":[{"name":"small","title":"Small"},{"name":"medium","title":"Medium"},{"name":"large","title":"Large"},{"name":"vlarge","title":"Very Large"}],"default":"medium","description":{"R":"Choose the node size for the variables (default: \"medium\").\n"}},{"name":"diag_shape_man","title":"Manifest shapes","type":"List","options":[{"name":"rectangle","title":"Rectangles"},{"name":"square","title":"Squares"},{"name":"circle","title":"Circles"},{"name":"ellipse","title":"Ellipses"},{"name":"diamond","title":"Diamonds"}],"default":"rectangle","description":{"R":"Choose the shape for the manifest variables (default: \"rectangle\").\n"}},{"name":"diag_shape_lat","title":"Latent shapes","type":"List","options":[{"name":"circle","title":"Circles"},{"name":"rectangle","title":"Rectangles"},{"name":"square","title":"Squares"},{"name":"ellipse","title":"Ellipses"},{"name":"diamond","title":"Diamonds"}],"default":"circle","description":{"R":"Choose the shape for the latent variables (default: \"circle\").\n"}},{"name":"diag_abbrev","title":"Abbreviate","type":"List","options":[{"name":"0","title":"No abbrev."},{"name":"5","title":"5"},{"name":"10","title":"10"},{"name":"15","title":"15"},{"name":"20","title":"20"},{"name":"25","title":"25"}],"default":"5","description":{"R":"Choose the length (characters) of the variable name abbreviations (default: 5).\n"}},{"name":"preds_lv","type":"Output","title":"Factor Scores","description":{"R":"none\n","ui":"this option saves, for each participant, the latent variables predicted values based on the latent variables estimation. The values are obtained with `lavaan::lavPredict(..,type=\"lv\")`. See @lavaan for details. The values are basically factor scores.\n"}},{"name":"preds_ov","type":"Output","title":"Indicators","description":{"R":"none\n","ui":"this option saves, for each participant, the observed variables predicted values based on the latent variables estimation. The values are obtained with `lavaan::lavPredict(..,type=\"ov\")`. See @lavaan for details\n"}},{"name":"preds_dv","type":"Output","title":"Dependent variables","description":{"R":"this option saves, for each participant, the model based predicted values of the observed variables involved in the measurement of purely endogenous dependent variables. The predicted values computation is based on @predict, and the implementation is adapted from [github SEMpredict](https://github.com/mjderooij/SEMpredict)\n","ui":"this option saves, for each participant, the model based predicted values of the observed variables involved in the measurement of purely endogenous dependent variables. The predicted values computation is based on @predict, and the implementation is adpted from [github SEMpredict](https://github.com/mjderooij/SEMpredict)\n"}}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./gui.events').update

    }).call(this);
}

view.layout = ui.extend({

    label: "Structural Equation Modeling",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			persistentItems: true,
			stretchFactor: 1,
			suggested: ["continuous","ordinal"],
			permitted: ["numeric"],
			controls: [
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Latent Endogenous Variables",
					controls: [
						{
							type: DefaultControls.ListBox,
							typeName: 'ListBox',
							name: "endogenous",
							height: "large",
							addButton: "Add New Latent",
							events: [
								{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
								{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
							],
							templateName: "linreg-block-template",
							template:
							{
								type: DefaultControls.LayoutBox,
								typeName: 'LayoutBox',
								margin: "normal",
								controls: [
									{
										type: DefaultControls.TextBox,
										typeName: 'TextBox',
										events: [
											{ execute: require('./gui.events').onChange_latentName }
										],
										valueKey: ["label"],
										borderless: true,
										name: "blockName",
										stretchFactor: 1,
										margin: "normal"
									},
									{
										type: DefaultControls.VariablesListBox,
										typeName: 'VariablesListBox',
										name: "blocklist",
										valueFilter: "unique",
										events: [
											{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
											{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
										],
										valueKey: ["vars"],
										isTarget: true,
										height: "auto",
										ghostText: "drag variables here"
									}
								]
							}							
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					label: "Latent Exogenous Variables",
					controls: [
						{
							type: DefaultControls.ListBox,
							typeName: 'ListBox',
							name: "exogenous",
							height: "large",
							addButton: "Add New Latent",
							templateName: "linreg-block-template",
							events: [
								{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
								{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
							],
							template:
							{
								type: DefaultControls.LayoutBox,
								typeName: 'LayoutBox',
								margin: "normal",
								controls: [
									{
										type: DefaultControls.TextBox,
										typeName: 'TextBox',
										events: [
											{ execute: require('./gui.events').onChange_latentName }
										],
										valueKey: ["label"],
										borderless: true,
										name: "blockName",
										stretchFactor: 1,
										margin: "normal"
									},
									{
										type: DefaultControls.VariablesListBox,
										typeName: 'VariablesListBox',
										valueFilter: "unique",
										events: [
											{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
											{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
										],
										valueKey: ["vars"],
										name: "blockList",
										isTarget: true,
										height: "auto",
										ghostText: "drag variables here"
									}
								]
							}							
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "multigroup",
							maxItemCount: 1,
							isTarget: true,
							itemDropBehaviour: "overwrite"
						}
					]
				}
			]
		},
		{
			type: DefaultControls.LayoutBox,
			typeName: 'LayoutBox',
			margin: "large",
			style: "inline",
			controls: [
				{
					type: DefaultControls.CheckBox,
					typeName: 'CheckBox',
					name: "donotrun"
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Second Oder Factors",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.Supplier,
							typeName: 'Supplier',
							name: "secondorderSupplier",
							label: "Defined Factors",
							format: FormatDef.term,
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ onEvent: 'update', execute: require('./gui.events').onUpdate_secondorderSupplier },
								{ execute: require('./gui.events').onChange_secondorderSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									label: "Second Order Factors",
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "secondorder",
											height: "large",
											addButton: "Add New Latent",
											events: [
												{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
												{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed }
											],
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												controls: [
													{
														type: DefaultControls.TextBox,
														typeName: 'TextBox',
														events: [
															{ execute: require('./gui.events').onChange_SecondName }
														],
														valueKey: ["label"],
														borderless: true,
														name: "blockName",
														stretchFactor: 1,
														margin: "normal"
													},
													{
														type: DefaultControls.VariablesListBox,
														typeName: 'VariablesListBox',
														valueFilter: "unique",
														events: [
															{ onEvent: 'listItemAdded', execute: require('./gui.events').onChange_items_changed },
															{ onEvent: 'listItemRemoved', execute: require('./gui.events').onChange_items_changed },
															{ execute: require('./gui.events').onChange_secondorderTerms }
														],
														valueKey: ["vars"],
														name: "blockList",
														isTarget: true,
														height: "auto",
														ghostText: "drag variables here"
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Endogenous models",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.Supplier,
							typeName: 'Supplier',
							label: "Defined Factors",
							name: "endogenousSupplier",
							format: FormatDef.term,
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ onEvent: 'update', execute: require('./gui.events').onUpdate_endogenousSupplier },
								{ execute: require('./gui.events').onChange_endogenousSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									label: "Endogenous Variables Models",
									transferAction: "interactions",
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "endogenousTerms",
											height: "large",
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												targetArea: true,
												controls: [
													{
														type: DefaultControls.Label,
														typeName: 'Label',
														label: "empty",
														name: "blockName",
														stretchFactor: 1,
														margin: "normal"
													},
													{
														type: DefaultControls.ListBox,
														typeName: 'ListBox',
														enable: "(endogenous)",
														name: "blockList",
														isTarget: true,
														valueFilter: "unique",
														height: "auto",
														ghostText: "drag variables here",
														events: [
															{ execute: require('./gui.events').onChange_endogenousTerms }
														],
														template:
														{
															type: DefaultControls.TermLabel,
															typeName: 'TermLabel'
														}														
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Variances and covariances",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.VariableSupplier,
							typeName: 'VariableSupplier',
							name: "varcovSupplier",
							populate: "manual",
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ execute: require('./gui.events').onChange_varcovSupplier },
								{ onEvent: 'update', execute: require('./gui.events').onUpdate_varcovSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									label: "Select pairs",
									controls: [
										{
											type: DefaultControls.VariablesListBox,
											typeName: 'VariablesListBox',
											name: "varcov",
											fullRowSelect: true,
											isTarget: true,
											events: [
												{ execute: require('./gui.events').onChange_varcov }
											],
											columns: [
												{
													name: "i1",
													stretchFactor: 1,
													template:
													{
														type: DefaultControls.VariableLabel,
														typeName: 'VariableLabel'
													}													
												},
												{
													name: "i2",
													stretchFactor: 1,
													template:
													{
														type: DefaultControls.VariableLabel,
														typeName: 'VariableLabel'
													}													
												}
											]
										}
									]
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Correlated",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cov_y"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cov_lv"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Custom model settings",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "constraints",
											events: [
												{ execute: require('./gui.events').onChange_constraints }
											],
											height: "large",
											addButton: "Add directive",
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												stretchFactor: 1,
												controls: [
													{
														type: DefaultControls.TextBox,
														typeName: 'TextBox',
														name: "randblockList",
														valueFilter: "unique",
														stretchFactor: 0.5,
														borderless: true,
														height: "auto",
														ghostText: "write here"
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Model options",
			name: "panel_modeloptions",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Estimation",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "estimator"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "likelihood",
									enable: "(estimator:ML || estimator:PML)"
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Data",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "missing"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Constraints tests",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "scoretest"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cumscoretest"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Parameters options",
			name: "parameters_options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Standard Errors",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_auto",
									optionName: "se",
									optionPart: "auto"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_standard",
									optionName: "se",
									optionPart: "standard"
								},
								{
									name: "se_robust.sem",
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									optionName: "se",
									optionPart: "robust.sem"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_robust.huber.white",
									optionName: "se",
									optionPart: "robust.huber.white"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_boot",
									optionName: "se",
									optionPart: "boot"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Bootstrap settings",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_bootperc",
									optionName: "bootci",
									optionPart: "perc",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_bootnorm",
									optionName: "bootci",
									optionPart: "norm",
									enable: "(se:boot)"
								},
								{
									name: "bootci_bca.simple",
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									optionName: "bootci",
									optionPart: "bca.simple",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_basic",
									optionName: "bootci",
									optionPart: "basic",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "bootN",
									format: FormatDef.number,
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "parallel",
									enable: "(se:boot)"
								}
							]
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Confidence Intervals",
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											style: "list",
											controls: [
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "est_ci"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "beta_ci"
												},
												{
													type: DefaultControls.TextBox,
													typeName: 'TextBox',
													name: "ci_width",
													format: FormatDef.number,
													suffix: "%",
													enable: "(est_ci || beta_ci)"
												}
											]
										}
									]
								},
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Constraints",
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "cov_x"
										}
									]
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Intercepts",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "meanstructure"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "int_ov",
									enable: "(meanstructure)"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "int_lv",
									enable: "(meanstructure)"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Estimates",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "indirect"
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Scale / standardize variables",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "std_lv_first",
									optionName: "std_lv",
									optionPart: "fix_first"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "std_lv_res",
									optionName: "std_lv",
									optionPart: "std_res"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "std_ov"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Multi-group analysis",
			name: "multigroup_options",
			collapsed: true,
			stretchFactor: 1,
			style: "list",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "list",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Equality constraints"
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "inline",
							controls: [
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_loadings"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_intercepts"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_means"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_thresholds"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_residuals"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_residual.covariances"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_regressions"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_lv.variances"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "eq_lv.covariances"
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Exploratory SEM options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.Supplier,
							typeName: 'Supplier',
							label: "Defined Factors",
							name: "esemSupplier",
							format: FormatDef.term,
							persistentItems: false,
							stretchFactor: 1,
							events: [
								{ onEvent: 'update', execute: require('./gui.events').onEvent_nothing },
								{ execute: require('./gui.events').onEvent_nothing }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									transferAction: "none",
									name: "esem_layout",
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "esem_terms",
											label: "Factors blocks",
											height: "normal",
											addButton: "Add factors block",
											events: [
												{ execute: require('./gui.events').onEvent_nothing }
											],
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												targetArea: true,
												controls: [
													{
														type: DefaultControls.ListBox,
														typeName: 'ListBox',
														name: "factorblockList",
														height: "auto",
														isTarget: true,
														valueFilter: "unique",
														ghostText: "drag term here",
														template:
														{
															type: DefaultControls.VariableLabel,
															typeName: 'VariableLabel'
														}														
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Rotation",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "rotation"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "algorithm"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "orthogonal"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "efa_std.ov"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Rotations options",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "geomin.epsilon",
									format: FormatDef.number,
									enable: "(rotation:geomin)"
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "orthomax.gamma",
									format: FormatDef.number,
									enable: "(rotation:orthomax)"
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "oblimin.gamma",
									format: FormatDef.number,
									enable: "(rotation:oblimin)"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Output options",
			name: "output_options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "inline",
									controls: [
										{
											type: DefaultControls.Label,
											typeName: 'Label',
											label: "Information"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "showlabels"
										},
										{
											type: DefaultControls.CheckBox,
											typeName: 'CheckBox',
											name: "constraints_examples"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									style: "inline",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.LayoutBox,
													typeName: 'LayoutBox',
													margin: "large",
													style: "list",
													controls: [
														{
															type: DefaultControls.Label,
															typeName: 'Label',
															label: "Additional outputs"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "outputAdditionalFitMeasures"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "outputMardiasCoefficients"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "reliability"
														},
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "htmt"
														}
													]
												},
												{
													type: DefaultControls.LayoutBox,
													typeName: 'LayoutBox',
													margin: "large",
													style: "list",
													controls: [
														{
															type: DefaultControls.Label,
															typeName: 'Label',
															label: "R-squared"
														},
														{
															type: DefaultControls.RadioButton,
															typeName: 'RadioButton',
															name: "r2_none",
															optionName: "r2",
															optionPart: "none"
														},
														{
															type: DefaultControls.RadioButton,
															typeName: 'RadioButton',
															name: "r2_endo",
															optionName: "r2",
															optionPart: "endo"
														},
														{
															type: DefaultControls.RadioButton,
															typeName: 'RadioButton',
															name: "r2_all",
															optionName: "r2",
															optionPart: "all"
														}
													]
												}
											]
										},
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.Label,
													typeName: 'Label',
													label: "Covariances and correlations"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputObservedCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputImpliedCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputResidualCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outpuCombineCovariances"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "cov.lv"
												}
											]
										},
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.Label,
													typeName: 'Label',
													label: "Modification indices"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "outputModificationIndices",
													controls: [
														{
															type: DefaultControls.CheckBox,
															typeName: 'CheckBox',
															name: "miHideLow",
															enable: "(outputModificationIndices)",
															controls: [
																{
																	type: DefaultControls.TextBox,
																	typeName: 'TextBox',
																	name: "miThreshold",
																	format: FormatDef.number,
																	enable: "(miHideLow)"
																}
															]
														}
													]
												},
												{
													type: DefaultControls.LayoutBox,
													typeName: 'LayoutBox',
													margin: "large",
													style: "list",
													controls: [
														{
															type: DefaultControls.Label,
															typeName: 'Label',
															label: "Save Predicted"
														},
														{
															type: DefaultControls.Output,
															typeName: 'Output',
															name: "preds_lv"
														},
														{
															type: DefaultControls.Output,
															typeName: 'Output',
															name: "preds_ov"
														},
														{
															type: DefaultControls.Output,
															typeName: 'Output',
															name: "preds_dv"
														}
													]
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Path diagram",
			name: "pathdiagram_options",
			collapsed: true,
			stretchFactor: 1,
			style: "list",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					style: "list",
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							style: "inline",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "diagram",
									style: "inline",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "none",
											stretchFactor: 1,
											style: "list",
											controls: [
												{
													type: DefaultControls.Label,
													typeName: 'Label',
													label: "Path diagram",
													style: "list",
													controls: [
														{
															type: DefaultControls.LayoutBox,
															typeName: 'LayoutBox',
															margin: "none",
															stretchFactor: 1,
															style: "inline",
															controls: [
																{
																	type: DefaultControls.CheckBox,
																	typeName: 'CheckBox',
																	name: "diag_resid",
																	enable: "(diagram)"
																},
																{
																	type: DefaultControls.CheckBox,
																	typeName: 'CheckBox',
																	name: "diag_intercepts",
																	enable: "(diagram && meanstructure)"
																}
															]
														}
													]
												}
											]
										}
									]
								}
							]
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							style: "inline",
							controls: [
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Paths",
									margin: "large",
									style: "list",
									controls: [
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_est",
											optionName: "diag_paths",
											optionPart: "est",
											enable: "(diagram)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_stand",
											optionName: "diag_paths",
											optionPart: "stand",
											enable: "(diagram)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_name",
											optionName: "diag_paths",
											optionPart: "name",
											enable: "(diagram)"
										},
										{
											type: DefaultControls.RadioButton,
											typeName: 'RadioButton',
											name: "diag_paths_hide",
											optionName: "diag_paths",
											optionPart: "hide",
											enable: "(diagram)"
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									stretchFactor: 1,
									style: "list",
									controls: [
										{
											type: DefaultControls.Label,
											typeName: 'Label',
											label: "Layout",
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_type",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_rotate",
													enable: "(diagram)"
												}
											]
										}
									]
								},
								{
									type: DefaultControls.LayoutBox,
									typeName: 'LayoutBox',
									margin: "large",
									stretchFactor: 1,
									style: "list",
									controls: [
										{
											type: DefaultControls.Label,
											typeName: 'Label',
											label: "Nodes",
											margin: "large",
											style: "list",
											controls: [
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_labsize",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_shape_man",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_shape_lat",
													enable: "(diagram)"
												},
												{
													type: DefaultControls.ComboBox,
													typeName: 'ComboBox',
													name: "diag_abbrev",
													enable: "(diagram)"
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./gui.events":1}],3:[function(require,module,exports){
const syntax = {
    measures: function(vars) {
      var found = false;
      var astring="";
      var terms="";
      for(let i = 0; i < vars.length; i++) {
          if (vars[i].vars===undefined | vars[i].vars===null)
               continue;
          if (vars[i].vars.length===0)
               continue;
          found=true;     
          terms=vars[i].vars.join("+");
          astring+=vars[i].label+'=~'+terms+'\n ';
    }
    this.lav_syntax=astring;
    return(found);

    },
    make: function(eterms,latnames) {
      
      var found=false;
      var astring="";
      var terms="";
        for(let i = 0; i < latnames.length; i++) {
          if (eterms[i]===undefined | eterms[i]===null)
              continue;
          if (eterms[i].length===0)
              continue;
          found=true;
          terms=eterms[i].join("+");
          astring+=latnames[i]+'~'+terms+'\n';
    }
    this.lav_syntax+=astring;
    return(found);
    },
    varcov: function(pairs) {
      var astring="";
      var terms="";
        for(let i = 0; i < pairs.length; i++) {
          if (pairs[i].i1===null | pairs[i].i2===null)
               continue;
          astring+=pairs[i].i1+'~~'+pairs[i].i2+'\n ';
    }
    this.lav_syntax+=astring;
    },
    constraints: function(alist) {
      
      var astring="";
      for(let i = 0; i < alist.length; i++) {
          if (alist[i]!==null)
              astring+=' '+alist[i]+'  \n ';
      }
      this.lav_syntax+=astring;
    },
    clean: function() {
      this.lav_syntax="";
      
    }

};

module.exports = syntax;

},{}]},{},[2])(2)
});